cookutils view cook @ rev 987

`cook pkgdb` include `cook splitdb` now.
author Aleksej Bobylev <al.bobylev@gmail.com>
date Mon Oct 23 23:12:42 2017 +0300 (2017-10-23)
parents b5c90a3bb215
children 03374082dafa
line source
1 #!/bin/sh
2 #
3 # Cook - A tool to cook and generate SliTaz packages. Read the README
4 # before adding or modifying any code in cook!
5 #
6 # Copyright (C) SliTaz GNU/Linux - GNU GPL v3
7 # Author: Christophe Lincoln <pankso@slitaz.org>
8 #
10 . /usr/lib/slitaz/libcook.sh
12 VERSION="3.2"
13 export output=raw
16 # Internationalization.
18 export TEXTDOMAIN='cook'
21 #
22 # Functions
23 #
25 usage() {
26 cat <<EOT
28 $(boldify "$(_ 'Usage:')") $(_ 'cook [package|command] [list|--option]')
30 $(boldify "$(_ 'Commands:')")
31 usage|help $(_ 'Display this short usage.')
32 setup $(_ 'Setup your build environment.')
33 *-setup $(_ 'Setup a cross environment.')
34 * = {arm|armv6hf|armv7|x86_64}
35 test $(_ 'Test environment and cook a package.')
36 list-wok $(_ 'List packages in the wok.')
37 search $(_ 'Simple packages search function.')
38 new $(_ 'Create a new package with a receipt.')
39 list $(_ 'Cook a list of packages.')
40 clean-wok $(_ 'Clean-up all packages files.')
41 clean-src $(_ 'Clean-up all packages sources.')
42 uncook $(_ 'Check for uncooked packages')
43 pkgdb $(_ 'Create packages DB lists and flavors.')
45 $(boldify "$(_ 'Options:')")
46 cook <pkg>
47 --clean -c $(_ 'clean the package in the wok.')
48 --install -i $(_ 'cook and install the package.')
49 --getsrc -gs $(_ 'get the package source tarball.')
50 --block -b $(_ 'block a package so cook will skip it.')
51 --unblock -ub $(_ 'unblock a blocked package.')
52 --cdeps $(_ 'check dependencies of cooked package.')
53 --pack $(_ 'repack an already built package.')
54 --debug $(_ 'display debugging messages.')
55 --continue $(_ 'continue running compile_rules.')
56 cook new <pkg>
57 --interactive -x $(_ 'create a receipt interactively.')
58 cook setup
59 --wok $(_ 'clone the cooking wok from Hg repo.')
60 --stable $(_ 'clone the stable wok from Hg repo.')
61 --undigest $(_ 'clone the undigest wok from Hg repo.')
62 --tiny $(_ 'clone the tiny SliTaz wok from Hg repo.')
63 --forced $(_ 'force reinstall of chroot packages.')
64 cook pkgdb
65 --flavors $(_ 'create up-to-date flavors files.')
66 cook splitdb $(_ 'create up-to-date split.db file.')
68 EOT
69 exit 0
70 }
73 # We don't want these escapes in web interface.
75 clean_log() {
76 sed -i -e 's|\[70G\[ \[1;32m| |' \
77 -e 's|\[0;39m \]||' $LOGS/${1:-$pkg}.log
78 }
81 # Be sure package exists in wok.
83 check_pkg_in_wok() {
84 [ -d "$WOK/$pkg" ] || die 'Unable to find package "%s" in the wok' "$pkg"
85 }
88 # Initialize files used in $CACHE
90 init_db_files() {
91 _ 'Creating directories structure in "%s"' "$SLITAZ"
92 mkdir -p $WOK $PKGS $SRC $CACHE $LOGS $FEEDS
93 _ 'Creating DB files in "%s"' "$CACHE"
94 touch $activity $command $broken $blocked $CACHE/webstat
95 chown www:www $cache/webstat
96 }
99 # QA: check a receipt consistency before building.
101 receipt_quality() {
102 _ 'QA: checking package receipt...'
104 for var in PACKAGE VERSION CATEGORY SHORT_DESC MAINTAINER WEB_SITE; do
105 unset value
106 value="$(. $receipt; eval echo \$$var)"
107 # L10n: QA is quality assurance
108 [ -n "$value" ] || die 'QA: empty variable: %s' "$var=\"\""
110 case "$var" in
111 CATEGORY)
112 valid="$(echo $PKGS_CATEGORIES)" # avoid newlines
113 if ! echo " $valid " | grep -q " $value "; then
114 _ 'QA: unknown category "%s"' "$value"
115 die 'Please, use one of: %s' "$valid"
116 fi
117 ;;
118 WEB_SITE)
119 # We don't check WGET_URL since if dl is needed it will fail.
120 # Break also if we're not online. Here error is not fatal.
121 if ifconfig | grep -A1 '^[a-z]*[0-9]' | fgrep -q 'addr:' && \
122 ! busybox wget -T 12 --spider $value 2>/dev/null; then
123 _ 'QA: unable to reach "%s"' "$value"
124 fi
125 ;;
126 esac
127 done
128 }
131 # Paths used in receipt and by cook itself.
133 set_paths() {
134 pkgdir="$WOK/$pkg"
135 . "$pkgdir/receipt"
136 basesrc="$pkgdir/source"
137 tmpsrc="$basesrc/tmp"
138 src="$basesrc/$PACKAGE-$VERSION"
139 taz="$pkgdir/taz"
140 pack="$taz/${1:-$PACKAGE}-$VERSION$EXTRAVERSION" # v2: multiple taz/* folders
141 fs="$pack/fs"
142 stuff="$pkgdir/stuff"
143 install="$pkgdir/install"
145 pkgsrc="${SOURCE:-$PACKAGE}-${KBASEVER:-$VERSION}"
146 lzma_tarball="$pkgsrc.tar.lzma"
148 [ -n "$PATCH" -a -z "$PTARBALL" ] && PTARBALL="$(basename $PATCH)"
150 if [ -n "$WANTED" ]; then
151 basesrc="$WOK/$WANTED/source"
152 src="$basesrc/$WANTED-$VERSION"
153 install="$WOK/$WANTED/install"
154 wanted_stuff="$WOK/$WANTED/stuff"
155 fi
157 [ -n "$SOURCE" ] && source_stuff="$WOK/$SOURCE/stuff"
159 # Kernel version is set from wok/linux or installed/linux-api-headers(wok-undigest)
160 if [ -f "$WOK/linux/receipt" ]; then
161 kvers=$(. $WOK/linux/receipt; echo $VERSION)
162 kbasevers=$(echo $kvers | cut -d. -f1,2)
163 elif [ -f "$INSTALLED/linux-api-headers/receipt" ]; then
164 kvers=$(. $INSTALLED/linux-api-headers/receipt; echo $VERSION)
165 kbasevers=$(echo $kvers | cut -d. -f1,2)
166 fi
168 # Python version
169 [ -f "$WOK/python/receipt" ] && pyvers=$(. $WOK/python/receipt; echo $VERSION)
170 # Perl version for some packages needed it
171 [ -f "$WOK/perl/receipt" ] && perlvers=$(. $WOK/perl/receipt; echo $VERSION)
173 # Old way compatibility.
174 _pkg="$install"
175 }
178 # Create source tarball when URL is a SCM.
180 create_tarball() {
181 local tarball
182 tarball="$pkgsrc.tar.bz2"
183 [ -n "$LZMA_SRC" ] && tarball="$lzma_tarball"
184 _ 'Creating tarball "%s"' "$tarball"
185 if [ -n "$LZMA_SRC" ]; then
186 tar -c $pkgsrc | lzma e $SRC/$tarball -si $LZMA_SET_DIR || exit 1
187 LZMA_SRC=''
188 else
189 tar -cjf $tarball $pkgsrc || exit 1
190 mv $tarball $SRC; rm -rf $pkgsrc
191 fi
192 TARBALL="$tarball"
193 }
196 # Get package source. For SCM we are in cache so clone here and create a
197 # tarball here.
199 get_source() {
200 local url
201 url=${WGET_URL#*|}
202 set_paths
203 pwd=$(pwd)
204 case "$WGET_URL" in
205 http://*|ftp://*|https://*)
206 url="$MIRROR_URL/sources/packages/${TARBALL:0:1}/$TARBALL"
207 wget -T 60 -c -O $SRC/$TARBALL $WGET_URL ||
208 wget -T 60 -c -O $SRC/$TARBALL $url ||
209 die 'ERROR: %s' "wget $WGET_URL"
210 ;;
212 hg*|mercurial*)
213 _ 'Getting source from %s...' 'Hg'
214 _ 'URL: %s' "$url"
215 _ 'Cloning to "%s"' "$pwd/$pkgsrc"
216 if [ -n "$BRANCH" ]; then
217 _ 'Hg branch: %s' "$BRANCH"
218 hg clone $url --rev $BRANCH $pkgsrc ||
219 die 'ERROR: %s' "hg clone $url --rev $BRANCH"
220 else
221 hg clone $url $pkgsrc || die 'ERROR: %s' "hg clone $url"
222 fi
223 rm -rf $pkgsrc/.hg
224 create_tarball
225 ;;
227 git*)
228 _ 'Getting source from %s...' 'Git'
229 _ 'URL: %s' "$url"
230 cd $SRC
231 git clone $url $pkgsrc || die 'ERROR: %s' "git clone $url"
232 if [ -n "$BRANCH" ]; then
233 _ 'Git branch: %s' "$BRANCH"
234 cd $pkgsrc; git checkout $BRANCH; cd ..
235 fi
236 cd $SRC
237 create_tarball
238 ;;
240 cvs*)
241 mod=$PACKAGE
242 [ -n "$CVS_MODULE" ] && mod=$CVS_MODULE
243 _ 'Getting source from %s...' 'CVS'
244 _ 'URL: %s' "$url"
245 [ -n "$CVS_MODULE" ] && _ 'CVS module: %s' "$mod"
246 _ 'Cloning to "%s"' "$pwd/$mod"
247 cvs -d:$url co $mod && mv $mod $pkgsrc
248 create_tarball
249 ;;
251 svn*|subversion*)
252 _ 'Getting source from %s...' 'SVN'
253 _ 'URL: %s' "$url"
254 if [ -n "$BRANCH" ]; then
255 echo t | svn co $url -r $BRANCH $pkgsrc
256 else
257 echo t | svn co $url $pkgsrc
258 fi
259 create_tarball
260 ;;
262 bzr*)
263 _ 'Getting source from %s...' 'bazaar'
264 cd $SRC
265 pkgsrc=${url#*:}
266 if [ -n "$BRANCH" ]; then
267 echo "bzr -Ossl.cert_reqs=none branch $url -r $BRANCH"
268 bzr -Ossl.cert_reqs=none branch $url -r $BRANCH
269 else
270 echo "bzr -Ossl.cert_reqs=none branch $url"
271 bzr -Ossl.cert_reqs=none branch $url
272 cd $pkgsrc; BRANCH=$(bzr revno); cd ..
273 _ "Don't forget to add to receipt:"
274 echo -e "BRANCH=\"$BRANCH\"\n"
275 fi
276 mv $pkgsrc $pkgsrc-$BRANCH
277 pkgsrc="$pkgsrc-$BRANCH"
278 create_tarball
279 ;;
281 *)
282 broken; die 'ERROR: Unable to handle "%s"' "$WGET_URL"
283 ;;
284 esac
285 }
288 # Extract source package.
290 extract_source() {
291 if [ ! -s "$SRC/$TARBALL" ]; then
292 local url
293 url="$MIRROR_URL/sources/packages"
294 url="$url/${TARBALL:0:1}/$TARBALL"
295 _ 'Getting source from %s...' 'mirror'
296 _ 'URL: %s' "$url"
297 busybox wget -c -P $SRC $url || _ 'ERROR: %s' "wget $url"
298 fi
299 _ 'Extracting source archive "%s"' "$TARBALL"
300 case "$TARBALL" in
301 *.tar.gz|*.tgz) tar -xzf $SRC/$TARBALL 2>/dev/null ;;
302 *.tar.bz2|*.tbz|*.tbz2) tar -xjf $SRC/$TARBALL 2>/dev/null ;;
303 *.tar.lzma) tar -xaf $SRC/$TARBALL ;;
304 *.tar.lz|*.tlz) lzip -d < $SRC/$TARBALL | tar -xf - 2>/dev/null ;;
305 *.tar) tar -xf $SRC/$TARBALL ;;
306 *.zip|*.xpi) unzip -o $SRC/$TARBALL 2>/dev/null >&2;;
307 *.xz) unxz -c $SRC/$TARBALL | tar -xf - || \
308 tar -xf $SRC/$TARBALL 2>/dev/null;;
309 *.7z) 7zr x $SRC/$TARBALL 2>/dev/null >&2 ;;
310 *.Z|*.z) uncompress -c $SRC/$TARBALL | tar -xf - ;;
311 *.rpm) rpm2cpio $SRC/$TARBALL | cpio -idm --quiet ;;
312 *.run) /bin/sh $SRC/$TARBALL $RUN_OPTS ;;
313 *) cp $SRC/$TARBALL $(pwd) ;;
314 esac
315 }
318 # Display time.
320 disp_time() {
321 local sec div min
322 sec="$1"
323 div=$(( ($1 + 30) / 60))
324 case $div in
325 0) min='';;
326 # L10n: 'm' is for minutes (approximate cooking time)
327 *) min=$(_n ' ~ %dm' "$div");;
328 esac
330 # L10n: 's' is for seconds (cooking time)
331 _ '%ds%s' "$sec" "$min"
332 }
335 # Display cooked package summary.
337 summary() {
338 set_paths
339 cd $WOK/$pkg
340 [ -d $WOK/$pkg/install ] && prod=$(du -sh $WOK/$pkg/install | awk '{print $1}' 2>/dev/null)
341 [ -d $WOK/$pkg/source ] && srcdir=$(du -sh $WOK/$pkg/source | awk '{print $1}' 2>/dev/null)
342 [ -n "$TARBALL" ] && srcsize=$(du -sh $SRC/$TARBALL | awk '{print $1}')
344 _ 'Summary for: %s' "$PACKAGE $VERSION"
345 separator
347 # L10n: keep the same width of translations to get a consistent view
348 [ -n "$TARBALL" ] && _ 'Src file : %s' "$TARBALL"
349 [ -n "$srcsize" ] && _ 'Src size : %s' "$srcsize"
350 [ -n "$srcdir" ] && _ 'Source dir : %s' "$srcdir"
351 [ -n "$prod" ] && _ 'Produced : %s' "$prod"
352 _ 'Cook time : %s' "$(disp_time "$time")"
353 _ 'Cook date : %s' "$(date "$(_ '+%%F %%R')")"
354 _ 'Host arch : %s' "$ARCH"
356 separator -
357 _ ' # : Packed : Compressed : Files : Package name'
358 separator -
359 pkgi=1
360 for i in $(all_names); do
361 fs=$(du -sh $WOK/$pkg/taz/$i-$VERSION | awk '{print $1}')
362 pkgname="$i-$VERSION.tazpkg"
363 size=$(ls -lh $PKGS/$pkgname | awk '{print $5}')
364 files=$(wc -l < $WOK/$pkg/taz/$i-$VERSION/files.list)
365 printf "%2d : %7s : %10s : %5s : %s\n" "$pkgi" "$fs" "$size" "$files" "$pkgname"
366 pkgi=$((pkgi + 1))
367 done
368 separator
369 }
372 # Display debugging error info.
374 debug_info() {
375 title 'Debug information'
376 # L10n: specify your format of date and time (to help: man date)
377 # L10n: not bad one is '+%x %R'
378 _ 'Cook date: %s' "$(date "$(_ '+%%F %%R')")"
379 if [ -n "$time" ]; then
380 times="$(($(date +%s) - $time))"
381 _ 'Wasted time : %s' "$(disp_time "$times")"
382 fi
383 for error in \
384 ERROR 'No package' "cp: can't" "can't open" "can't cd" \
385 'error:' 'fatal error:' 'undefined reference to' \
386 'Unable to connect to' 'link: cannot find the library' \
387 'CMake Error' ': No such file or directory' \
388 'Could not read symbols: File in wrong format'
389 do
390 # format "line number:line content"
391 fgrep -n "$error" $LOGS/$pkg.log
392 done > $LOGS/$pkg.log.debug_info 2>&1
393 # sort by line number, remove duplicates
394 sort -gk1,1 -t: -u $LOGS/$pkg.log.debug_info
395 rm -f $LOGS/$pkg.log.debug_info
396 footer
397 }
400 # A bit smarter function than the classic `cp` command
402 scopy() {
403 if [ "$(stat -c %h -- "$1")" -eq 1 ]; then
404 cp -a "$1" "$2" # copy generic files
405 else
406 cp -al "$1" "$2" # copy hardlinks
407 fi
408 }
411 # Copy all generic files (locale, pixmaps, .desktop) from $install to $fs.
412 # We use standard paths, so some packages need to copy these files with the
413 # receipt and genpkg_rules.
414 # This function executes inside the packaging process, before compressor call.
416 copy_generic_files() {
417 # Proceed only for "main" package (for v2), and for any packages (v1)
418 [ "$pkg" == "$PACKAGE" ] || return 0
420 # $LOCALE is set in cook.conf
421 if [ -n "$LOCALE" -a -z "$WANTED" ]; then
422 if [ -d "$install/usr/share/locale" ]; then
423 mkdir -p "$fs/usr/share/locale"
424 for i in $LOCALE; do
425 if [ -d "$install/usr/share/locale/$i" ]; then
426 cp -r $install/usr/share/locale/$i $fs/usr/share/locale
427 fi
428 done
429 fi
430 fi
432 # Generic pixmaps copy can be disabled with COOKOPTS="!pixmaps" (or GENERIC_PIXMAPS="no")
433 if [ "${COOKOPTS/!pixmaps/}" == "$COOKOPTS" -a "$GENERIC_PIXMAPS" != 'no' ]; then
434 if [ -d "$install/usr/share/pixmaps" ]; then
435 mkdir -p "$fs/usr/share/pixmaps"
436 for i in png xpm; do
437 [ -f "$install/usr/share/pixmaps/$PACKAGE.$i" -a ! -f "$fs/usr/share/pixmaps/$PACKAGE.$i" ] &&
438 cp -r $install/usr/share/pixmaps/$PACKAGE.$i $fs/usr/share/pixmaps
439 done
440 fi
441 fi
443 # Desktop entry (.desktop).
444 # Generic desktop entry copy can be disabled with COOKOPTS="!menus" (or GENERIC_MENUS="no")
445 if [ "${COOKOPTS/!menus/}" == "$COOKOPTS" -a "$GENERIC_MENUS" != 'no' ]; then
446 if [ -d "$install/usr/share/applications" -a -z "$WANTED" ]; then
447 mkdir -p "$fs/usr/share"
448 cp -r $install/usr/share/applications $fs/usr/share
449 fi
450 fi
451 }
454 # Copy pixmaps, desktop files and licenses from $stuff to $install.
455 # This function executes after the main compile_rules() is done.
457 copy_generic_stuff() {
458 # Custom or homemade PNG pixmap can be in stuff.
459 if [ -f "$stuff/$PACKAGE.png" ]; then
460 mkdir -p $install/usr/share/pixmaps
461 cp $stuff/$PACKAGE.png $install/usr/share/pixmaps
462 fi
464 # Homemade desktop file(s) can be in stuff.
465 if [ -d "$stuff/applications" ]; then
466 mkdir -p $install/usr/share
467 cp -r $stuff/applications $install/usr/share
468 fi
469 if [ -f "$stuff/$PACKAGE.desktop" ]; then
470 mkdir -p $install/usr/share/applications
471 cp $stuff/$PACKAGE.desktop $install/usr/share/applications
472 fi
474 # Add custom licenses
475 if [ -d "$stuff/licenses" ]; then
476 mkdir -p $install/usr/share/licenses
477 cp -r $stuff/licenses $install/usr/share/licenses/$PACKAGE
478 fi
479 }
482 # Remove files provided by split packages
483 # For example:
484 # 1. Package "pkg-main":
485 # SPLIT="pkg-1 pkg-2 pkg-extra"
486 # 2. Package="pkg-extra":
487 # WANTED="pkg-main"
488 # BUILD_DEPENDS="pkg-1 pkg-2"
489 # cook_copy_folders usr
490 # cook_split_rm $BUILD_DEPENDS
492 cook_split_rm() {
493 for i in $@; do
494 action 'Remove files provided by split package %s...' "$i"
495 while read j; do
496 [ -f "$fs$j" -o -h "$fs$j" ] && rm $fs$j
497 rmdir "$(dirname "$fs$j")" 2>/dev/null
498 done < $WOK/$i/taz/$i-$VERSION/files.list
499 :; status
500 done
501 }
504 # Update installed.cook.diff
506 update_installed_cook_diff() {
507 # If a cook failed deps are removed.
508 cd $root$INSTALLED; ls -1 > $CACHE/installed.cook
509 cd $CACHE
510 [ "$1" == 'force' -o ! -s '/tmp/installed.cook.diff' ] && \
511 busybox diff installed.list installed.cook > /tmp/installed.cook.diff
512 deps=$(grep ^+[a-zA-Z0-9] /tmp/installed.cook.diff | wc -l)
513 }
516 # Remove installed deps.
518 remove_deps() {
519 # Now remove installed build deps.
520 diff='/tmp/installed.cook.diff'
521 [ -s "$diff" ] || return
523 deps=$(grep ^+[a-zA-Z0-9] $diff | sed 's|^+||')
524 nb=$(grep ^+[a-zA-Z0-9] $diff | wc -l)
525 newline
526 _n 'Build dependencies to remove:'; echo " $nb"
527 [ -n "$root" ] && echo "root=\"$root\""
528 {
529 _n 'Removing:'
530 for dep in $deps; do
531 echo -n " $dep"
532 # Do not waste time uninstalling the packages if we are inside
533 # aufs chroot - unmounting chroot will "uninstall" all packages.
534 [ -s /aufs-umount.sh ] ||
535 echo 'y' | tazpkg remove $dep --root=$root >/dev/null
536 done
537 } | busybox fold -sw80
538 newline; newline
539 # Keep the last diff for debug and info.
540 mv -f $diff $CACHE/installed.diff
541 }
544 # Automatically patch the sources.
546 patchit() {
547 [ -f "$stuff/patches/series" ] || return
549 IFS=$'\n'
550 while read i; do
551 patchname=$(echo ${i%%#*} | cut -d' ' -f1) # allow comments (anything after the # or space)
552 case $patchname in # allow patch options in form <options_no_spaces>|<file_name>
553 *\|*) patchopts="${patchname%|*}"; patchname="${patchname#*|}";;
554 *) patchopts='-Np1';;
555 esac
556 [ -n "$patchname" ] || continue # allow empty lines
557 [ -f "$src/done.$patchname" ] && continue # already applied (useful with `cook --continue`)
558 newline
559 _ 'Applying patch %s' "$patchname"
560 patch $patchopts -i $stuff/patches/$patchname | sed 's|^| |'
561 touch $src/done.$patchname
562 done < $stuff/patches/series
563 newline
564 unset IFS
565 }
568 # Check source tarball integrity.
570 check_integrity() {
571 for i in sha1 sha3 sha256 sha512 md5; do
572 I=$(echo $i | tr 'a-z' 'A-Z')
573 eval sum=\$TARBALL_$I
574 if [ -n "$sum" ]; then
575 newline
576 _ 'Checking %ssum of source tarball...' "$i"
577 echo "$sum $SRC/$TARBALL" | ${i}sum -c || exit 1
578 fi
579 done
580 newline
581 }
584 # The main cook function.
586 cookit() {
587 if [ -n "$SETUP_MD5" -a "$SETUP_MD5" != "$(ls $root$INSTALLED | md5sum | cut -c1-32)" ]; then
588 _ 'ERROR: Broken setup. Abort.'
589 return
590 fi
592 title 'Cook: %s' "$PACKAGE $VERSION"
593 set_paths
595 # Handle cross-tools.
596 case "$ARCH" in
597 arm*|x86_64)
598 # CROSS_COMPILE is used by at least Busybox and the kernel to set
599 # the cross-tools prefix. Sysroot is the root of our target arch
600 sysroot="$CROSS_TREE/sysroot"
601 tools="$CROSS_TREE/tools"
602 # Set root path when cross compiling. ARM tested but not x86_64
603 # When cross compiling we must install build deps in $sysroot.
604 arch="-$ARCH"
605 root="$sysroot"
606 _ '%s sysroot: %s' "$ARCH" "$sysroot"
607 _ 'Adding "%s" to PATH' "$tools/bin"
608 export PATH="$PATH:$tools/bin"
609 export PKG_CONFIG_PATH="$sysroot/usr/lib/pkgconfig"
610 export CROSS_COMPILE="$HOST_SYSTEM-"
611 _ 'Using cross-tools: %s' "$CROSS_COMPILE"
612 if [ "$ARCH" == 'x86_64' ]; then
613 export CC="$HOST_SYSTEM-gcc -m64"
614 export CXX="$HOST_SYSTEM-g++ -m64"
615 else
616 export CC="$HOST_SYSTEM-gcc"
617 export CXX="$HOST_SYSTEM-g++"
618 fi
619 export AR="$HOST_SYSTEM-ar"
620 export AS="$HOST_SYSTEM-as"
621 export RANLIB="$HOST_SYSTEM-ranlib"
622 export LD="$HOST_SYSTEM-ld"
623 export STRIP="$HOST_SYSTEM-strip"
624 export LIBTOOL="$HOST_SYSTEM-libtool"
625 ;;
626 esac
628 [ -n "$QA" ] && receipt_quality
630 cd $pkgdir
631 [ -z "$continue" ] && rm -rf source 2>/dev/null
632 rm -rf install taz 2>/dev/null
634 # Disable -pipe if less than 512 MB free RAM.
635 free=$(awk '/^MemFree|^Buffers|^Cached/{s+=$2}END{print int(s/1024)}' /proc/meminfo)
636 if [ "$free" -lt 512 ] && [ "$CFLAGS" != "${CFLAGS/-pipe}" ]; then
637 _ 'Disabling -pipe compile flag: %d MB RAM free' "$free"
638 CFLAGS="${CFLAGS/-pipe}"; CFLAGS=$(echo "$CFLAGS" | tr -s ' ')
639 CXXFLAGS="${CXXFLAGS/-pipe}"; CXXFLAGS=$(echo "$CXXFLAGS" | tr -s ' ')
640 fi
641 unset free
643 # Export flags and path to be used by make and receipt.
644 DESTDIR="$pkgdir/install"
645 # FIXME: L10n: Is this the right time for 'LC_ALL=C LANG=C'?
646 export DESTDIR MAKEFLAGS CFLAGS CXXFLAGS CONFIG_SITE LC_ALL=C LANG=C
647 #LDFLAGS
649 # BUILD_DEPENDS may vary depending on the ARCH
650 case "$ARCH" in
651 arm*) [ -n "$BUILD_DEPENDS_arm" ] && BUILD_DEPENDS=$BUILD_DEPENDS_arm ;;
652 x86_64) [ -n "$BUILD_DEPENDS_x86_64" ] && BUILD_DEPENDS=$BUILD_DEPENDS_x86_64 ;;
653 esac
655 # Check for build deps and handle implicit depends of *-dev packages
656 # (ex: libusb-dev :: libusb).
657 # rm -f $CACHE/installed.local $CACHE/installed.web $CACHE/missing.dep
658 # touch $CACHE/installed.local $CACHE/installed.web
659 [ -n "$BUILD_DEPENDS" ] && _ 'Checking build dependencies...'
660 [ -n "$root" ] && _ 'Using packages DB: %s' "$root$DB"
662 # Get the list of installed packages
663 cd $root$INSTALLED; ls > $CACHE/installed.list
665 for action in check install; do
666 for dep in $BUILD_DEPENDS; do
667 implicit="${dep%-dev}"; [ "$implicit" == "$dep" ] && implicit=''
668 for i in $dep $implicit; do
669 # Skip if package already installed
670 [ -f "$root$INSTALLED/$i/receipt" ] && continue
672 case $action in
673 check)
674 # Search for local package or local provided-package
675 name=$(awk -F$'\t' -vpkg="$i" '{
676 if (index(" " $1 " " $10 " ", " " pkg " ")) {print $1; exit}
677 }' "$PKGS/packages.info")
678 if [ -z "$name" ]; then
679 # Search for package in mirror
680 name="$(awk -F$'\t' -vi="$i" '$1==i{print $1; exit}' "$root$DB/packages.info")"
681 [ -z "$name" -a "$i" == "$dep" ] && die 'ERROR: unknown dep "%s"' "$i"
682 fi
683 ;;
684 install)
685 tazpkg get-install $i --root=$root --local --quiet --cookmode || { broken; exit 1; }
686 ;;
687 esac
688 done
689 done
690 done
692 # # Have we a missing build dep to cook?
693 # if [ -s "$CACHE/missing.dep" ] && [ -n "$AUTO_COOK" ]; then
694 # _ 'Auto cook config is set: %s' "$AUTO_COOK"
695 # cp -f $LOGS/$PACKAGE.log $LOGS/$PACKAGE.log.$$
696 # for i in $(uniq $CACHE/missing.dep); do
697 # (_ 'Building dep (wok/pkg) : %s' "$i $vers") | \
698 # tee -a $LOGS/$PACKAGE.log.$$
699 # # programmers: next two messages are exact copy from remove_deps()
700 # togrep1=$(_n 'Build dependencies to remove:')
701 # togrep2=$(_n 'Removing:')
702 # cook $i || (_ "ERROR: can't cook dep \"%s\"" "$i" && newline && \
703 # fgrep $togrep1 $LOGS/$i.log && \
704 # fgrep $togrep2 $LOGS/$i.log && newline) | \
705 # tee -a $LOGS/$PACKAGE.log.$$ && break
706 # done
707 # rm -f $CACHE/missing.dep
708 # mv $LOGS/$PACKAGE.log.$$ $LOGS/$PACKAGE.log
709 # fi
710 #
711 # # QA: Exit on missing dep errors. We exit in both cases, if AUTO_COOK
712 # # is enabled and cook fails we have ERROR in log, if no auto cook we have
713 # # missing dep in cached file.
714 # lerror=$(_n 'ERROR')
715 # if fgrep -q ^$lerror $LOGS/$pkg.log || [ -s "$CACHE/missing.dep" ]; then
716 # [ -s "$CACHE/missing.dep" ] && nb=$(wc -l < $CACHE/missing.dep)
717 # _p 'ERROR: missing %d dependency' 'ERROR: missing %d dependencies' "$nb" "$nb"
718 # broken; exit 1
719 # fi
720 #
721 # # Install local packages: package-version$arch
722 # cd $PKGS
723 # for i in $(uniq $CACHE/installed.local); do
724 # # _ 'Installing dep (pkg/local): %s' "$i"
725 # tazpkg install $i --root=$root --local --quiet --cookmode
726 # done
727 #
728 # # Install web or cached packages (if mirror is set to $PKGS we only
729 # # use local packages).
730 # for i in $(uniq $CACHE/installed.web); do
731 # # _ 'Installing dep (web/cache): %s' "$i"
732 # tazpkg get-install $i --root=$root --local --quiet --cookmode
733 # done
735 update_installed_cook_diff
737 # Get source tarball and make sure we have source dir named:
738 # $PACKAGE-$VERSION to be standard in receipts. Here we use tar.lzma
739 # tarball if it exists.
740 if [ -n "$WGET_URL" -a ! -f "$SRC/$TARBALL" ]; then
741 if [ -f "$SRC/${SOURCE:-$PACKAGE}-$VERSION.tar.lzma" ]; then
742 TARBALL="${SOURCE:-$PACKAGE}-$VERSION.tar.lzma"
743 LZMA_SRC=''
744 else
745 get_source || { broken; exit 1; }
746 fi
747 fi
748 if [ -z "$WANTED" -a -n "$TARBALL" -a ! -d "$src" ]; then
749 mkdir -p $pkgdir/source/tmp; cd $pkgdir/source/tmp
750 if ! extract_source ; then
751 get_source
752 extract_source || { broken; exit 1; }
753 fi
754 if [ -n "$LZMA_SRC" ]; then
755 cd $pkgdir/source
756 if [ "$(ls -A tmp | wc -l)" -gl 1 -o -f "$(echo tmp/*)" ]; then
757 mv tmp tmp-1; mkdir tmp
758 mv tmp-1 tmp/${SOURCE:-$PACKAGE}-$VERSION
759 fi
760 if [ -d "tmp/${SOURCE:-$PACKAGE}-$VERSION" ]; then
761 cd tmp; tar -c * | lzma e $SRC/$TARBALL -si
762 fi
763 fi
764 cd $pkgdir/source/tmp
765 # Some archives are not well done and don't extract to one dir (ex lzma).
766 files=$(ls | wc -l)
767 [ "$files" -eq 1 -a -d "$(ls)" ] && mv * ../$PACKAGE-$VERSION
768 [ "$files" -eq 1 -a -f "$(ls)" ] && mkdir -p ../$PACKAGE-$VERSION && \
769 mv * ../$PACKAGE-$VERSION/$TARBALL
770 [ "$files" -gt 1 ] && mkdir -p ../$PACKAGE-$VERSION && \
771 mv * ../$PACKAGE-$VERSION
772 cd ..; rm -rf tmp
773 fi
775 check_integrity
777 # Libtool shared libs path hack.
778 case "$ARCH" in
779 arm*) cross libhack ;;
780 esac
782 # Execute receipt rules.
783 if grep -q ^compile_rules $receipt; then
784 _ 'Executing: %s' 'compile_rules'
785 echo "CFLAGS : $CFLAGS"
786 #echo "LDFLAGS : $LDFLAGS"
787 [ -d "$src" ] && cd $src
788 patchit
789 compile_rules $@ || { broken; exit 1; }
790 # Stay compatible with _pkg
791 [ -d "$src/_pkg" ] && mv $src/_pkg $install
792 # QA: compile_rules success so valid.
793 mkdir -p $install
794 else
795 # QA: no compile_rules so no error, valid.
796 mkdir -p $install
797 fi
799 copy_generic_stuff
801 # Actions to do after compiling the package
802 # Skip all for split packages (already done in main package)
803 if [ -z "$WANTED" ]; then
804 footer
805 export COOKOPTS ARCH install; @@PREFIX@@/libexec/cookutils/compressor install
806 fi
807 footer
809 # Execute testsuite.
810 if grep -q ^testsuite $receipt; then
811 title 'Running testsuite'
812 testsuite $@ || { broken; exit 1; }
813 footer
814 fi
816 update_installed_cook_diff force
817 }
820 # Cook quality assurance.
822 cookit_quality() {
823 if [ ! -d "$WOK/$pkg/install" ] && [ -z "$WANTED" ]; then
824 _ 'ERROR: cook failed' | tee -a $LOGS/$pkg.log
825 fi
827 [ "${COOKOPTS/skip-log-errors/}" != "$COOKOPTS" ] && return 0
829 # ERROR can be echoed any time in cookit()
830 if grep -Ev "(conftest|configtest)" $LOGS/$pkg.log | \
831 grep -Eq "(^ERROR|undefined reference to)" ; then
832 debug_info | tee -a $LOGS/$pkg.log
833 sed -i '$ s|$| [ Failed ]|' $activity
834 rm -f $command
835 broken; exit 1
836 fi
837 }
840 # Receipt used for cooking the package is redundant to be included into package.
841 # This script will strip the original receipt to bare minimum: variables,
842 # {pre,post}_{install,remove} functions.
844 mk_pkg_receipt() {
845 orig_receipt="$1"
847 # Receipt's signature is important, although some receipts may miss it
848 signature=$(head -n1 "$orig_receipt")
849 [ "${signature:0:1}" == '#' ] || signature='# SliTaz package receipt.'
851 save_PACKAGE="$PACKAGE"; save_DEPENDS="$DEPENDS"; save_PROVIDE="$PROVIDE"
852 save_SUGGESTED="$SUGGESTED"; save_TAZPANEL_DAEMON="$TAZPANEL_DAEMON"
853 save_TAGS="$TAGS"
854 unset_receipt
855 . "$orig_receipt"
856 PACKAGE="$save_PACKAGE"; DEPENDS="$save_DEPENDS"; PROVIDE="$save_PROVIDE"
857 SUGGESTED="$save_SUGGESTED"; TAZPANEL_DAEMON="$save_TAZPANEL_DAEMON"
858 TAGS="$save_TAGS"
860 # Manage split packages
861 SPLIT=" $SPLIT "
862 if [ "$SPLIT" != ' ' -a "${SPLIT/ $PACKAGE /}" != "$SPLIT" ]; then
863 # For packages with empty $DEPENDS
864 if [ -z "$DEPENDS" ]; then
865 case $PACKAGE in
866 *-dev)
867 # main package and all the split packages but this *-dev itself
868 DEPENDS=$(echo "$pkg $SPLIT " | sed "s| $PACKAGE | |; s| *$||") ;;
869 *)
870 # main package
871 DEPENDS="$pkg" ;;
872 esac
873 fi
875 # Default $CAT
876 [ -z "$CAT" ] &&
877 case $PACKAGE in
878 *-dev) CAT="development|development files" ;;
879 esac
880 fi
882 # Manage two-in-one $CAT="$CATEGORY|$SHORT_DESC_ADDITION"
883 if [ -n "$CAT" ]; then
884 CATEGORY="${CAT%|*}"
885 SHORT_DESC="$SHORT_DESC (${CAT#*|})"
886 fi
888 # escape quotes for receipt
889 SHORT_DESC="${SHORT_DESC//\"/\\\"}"
891 # Mandatory variables
892 cat <<EOF
893 $signature
895 PACKAGE="$PACKAGE"
896 VERSION="$VERSION"
897 CATEGORY="$CATEGORY"
898 SHORT_DESC="$SHORT_DESC"
899 MAINTAINER="$MAINTAINER"
900 LICENSE="$LICENSE"
901 WEB_SITE="$WEB_SITE"
902 EOF
904 # Optional variables
905 [ -n "$TAGS" ] && echo "TAGS=\"$TAGS\"" | tr -ds '\t' ' '
906 [ -n "${DEPENDS# }" ] && echo "DEPENDS=\"$DEPENDS\"" | tr -ds '\t' ' '
907 [ -n "$PROVIDE" ] && echo "PROVIDE=\"$PROVIDE\"" | tr -ds '\t' ' '
908 [ -n "$CONFIG_FILES" ] && echo "CONFIG_FILES=\"$CONFIG_FILES\"" | tr -ds '\t' ' '
909 [ -n "$SUGGESTED" ] && echo "SUGGESTED=\"$SUGGESTED\"" | tr -ds '\t' ' '
910 [ -n "$DATABASE_FILES" ] && echo "DATABASE_FILES=\"$DATABASE_FILES\""
911 [ -n "$TAZPANEL_DAEMON" ] && echo "TAZPANEL_DAEMON=\"$TAZPANEL_DAEMON\""
913 # Extract {pre,post}_{install,remove} functions;
914 # post_install() will be copied for both main and all the split packages
915 # post_install_gtk_() will be copied as post_install() for gtk+ package only
916 #
917 # restricted name (gtk+ -> gtk_; acl-dev -> acl_dev)
918 rname=$(echo -n $PACKAGE | tr -c 'a-zA-Z0-9' '_')
919 for i in pre post; do
920 for j in install remove; do
921 sed "/^${i}_${j}()/,/^}/!d" "$orig_receipt"
922 sed "/^${i}_${j}_$rname()/,/^}/!d" "$orig_receipt" | \
923 sed "s|^${i}_${j}_$rname()|${i}_${j}()|"
924 done
925 done
926 }
929 # Create the package. Wanted to use TazPkg to create a tazpkg package at first,
930 # but it doesn't handle EXTRAVERSION.
932 packit() {
933 set_paths "$1"
934 PACKAGE="${1:-$PACKAGE}"
936 # Handle cross compilation
937 case "$ARCH" in
938 arm*|x86_64) arch="-$ARCH" ;;
939 esac
941 title 'Pack: %s' "$PACKAGE $VERSION$arch"
943 if grep -q ^genpkg_rules $receipt; then
944 _ 'Executing: %s' 'genpkg_rules'
945 set -e; cd $pkgdir; mkdir -p $fs
946 genpkg_rules || (newline; _ 'ERROR: genpkg_rules failed'; newline) >> \
947 $LOGS/$pkg.log
948 else
949 _ 'No packages rules: meta package'
950 mkdir -p $fs
951 fi
953 # Check CONFIG_FILES
954 if [ -n "$CONFIG_FILES" ]; then
955 unset IFS
956 for i in $CONFIG_FILES; do
957 if [ ! -e $fs$i ]; then
958 case $i in
959 */) mkdir -p $fs$i ;;
960 *) mkdir -p $fs$(dirname $i); touch $fs$i ;;
961 esac
962 fi
963 done
964 fi
966 # First QA check to stop now if genpkg_rules failed.
967 lerror=$(_n 'ERROR')
968 if fgrep -q ^$lerror $LOGS/$pkg.log; then
969 broken; exit 1
970 fi
972 cd $taz
973 action 'Copying "%s"...' 'receipt'
974 mk_pkg_receipt ../receipt > $pack/receipt
975 chown 0.0 $pack/receipt; status
977 unset desc
978 [ "$pkg" == "$PACKAGE" -a -f "../description.txt" ] && desc="../description.txt"
979 [ -f "../description.$PACKAGE.txt" ] && desc="../description.$PACKAGE.txt"
980 if [ -n "$desc" ]; then
981 action 'Copying "%s"...' "$(basename "$desc")"
982 cp -f $desc $pack/description.txt; chown 0.0 $pack/description.txt; status
983 fi
985 copy_generic_files
987 # Strip and stuff files.
988 export COOKOPTS ARCH HOST_SYSTEM LOCALE fs; @@PREFIX@@/libexec/cookutils/compressor fs
990 # Create files.list with redirecting find output.
991 action 'Creating the list of files...'
992 cd $fs
993 find . -type f -print > ../files.list
994 find . -type l -print >> ../files.list
995 cd ..; sed -i 's|^.||' files.list
996 status
998 # Md5sum of files.
999 action 'Creating md5sum of files...'
1000 while read file; do
1001 [ -L "fs$file" ] && continue
1002 [ -f "fs$file" ] || continue
1003 case "$file" in
1004 /lib/modules/*/modules.*|*.pyc) continue ;;
1005 esac
1006 md5sum "fs$file" | sed 's| fs| |'
1007 done < files.list | sort -k2 > md5sum
1008 status
1010 UNPACKED_SIZE=$(du -chs fs receipt files.list md5sum description.txt \
1011 2>/dev/null | awk 'END{ print $1 }')
1013 # Build cpio archive.
1014 action 'Compressing the FS...'
1015 find fs -newer $receipt -exec touch -hr $receipt '{}' \;
1016 find fs | cpio -o -H newc --quiet | lzma-alone e fs.cpio.lzma -si
1017 # find fs | cpio -o -H newc --quiet | /bin/lzma -zeT0 -vv >fs.cpio.lzma
1018 mv fs ../
1019 status
1021 PACKED_SIZE=$(du -chs fs.cpio.lzma receipt files.list md5sum description.txt \
1022 2>/dev/null | awk 'END{ print $1 }')
1024 action 'Updating receipt sizes...'
1025 sed -i '/^PACKED_SIZE=/d; /^UNPACKED_SIZE=/d' receipt
1026 sed -i "s|^PACKAGE=|PACKED_SIZE=\"$PACKED_SIZE\"\nUNPACKED_SIZE=\"$UNPACKED_SIZE\"\nPACKAGE=|" receipt
1027 status
1029 # Set extra version.
1030 if [ -n "$EXTRAVERSION" ]; then
1031 action 'Updating receipt EXTRAVERSION: %s' "$EXTRAVERSION"
1032 sed -i '/^EXTRAVERSION=/d' receipt
1033 sed -i "s|^VERSION=|EXTRAVERSION=\"$EXTRAVERSION\"\nVERSION=|" receipt
1034 status
1035 fi
1037 # Compress.
1038 action 'Creating full cpio archive...'
1039 find . -newer $receipt -exec touch -hr $receipt '{}' \;
1040 find . | cpio -o -H newc --quiet > ../$PACKAGE-$VERSION$EXTRAVERSION$arch.tazpkg
1041 status
1043 # action 'Restoring original package tree...'
1044 mv ../fs .
1045 # status
1047 rm fs.cpio.lzma; cd ..
1049 # QA and give info.
1050 tazpkg=$(ls *.tazpkg)
1051 packit_quality
1052 footer "$(_ 'Package "%s" created' "$tazpkg")"
1053 update_packages_db
1057 # Calculate release checksum: usually it does not change on "just recook".
1058 # Release checksum is md5sum of file containing md5sums of:
1059 # a) all files, b) receipt, and c) description.txt.
1060 # Md5sum of the package file will change every time because of embedded timestamps;
1061 # release checksum based only on files content, and will change only when files change.
1062 # (Pitfall: ownership and permissions...)
1064 release_checksum() {
1065 local pack=$1
1066 local rsum_file=$(mktemp)
1068 cp $pack/md5sum $rsum_file
1069 md5sum $pack/receipt | sed 's| [^ ]*/| |' >> $rsum_file
1070 [ -e "$pack/description.txt" ] &&
1071 md5sum $pack/description.txt | sed 's| [^ ]*/| |' >> $rsum_file
1073 local rsum=$(md5sum $rsum_file | awk '{print $1}')
1074 rm $rsum_file
1075 local rsumold=$(awk -F$'\t' -vpkg="$PACKAGE" '
1076 {if ($1 == pkg) { print $9; exit; }}' $PKGS/packages.info)
1078 [ "$rsum" == "$rsumold" ] && rsum=''
1080 echo $rsum
1084 # Verify package quality and consistency.
1086 packit_quality() {
1087 #action 'QA: checking for broken link...'
1088 #link=$(find $fs/usr -type l -follow)
1089 #[ "$link" ] && echo -e "\nERROR: broken link in filesystem"
1090 #status
1092 if [ "${COOKOPTS/skip-log-errors/}" == "$COOKOPTS" ]; then
1093 # Exit if any error found in log file.
1094 if fgrep -q ^ERROR $LOGS/$pkg.log; then
1095 rm -f $command
1096 broken; exit 1
1097 fi
1098 fi
1100 if [ "${COOKOPTS/empty-pkg/}" == "$COOKOPTS" ]; then
1101 action 'QA: checking for empty package...'
1102 if [ ! -s "$pack/files.list" -a "$CATEGORY" != 'meta' ]; then
1103 broken
1104 rm -f $command
1105 false; status
1106 die 'ERROR: empty package'
1107 fi
1108 :; status
1109 fi
1112 # Find and remove old package(s) only if "release checksum" has changed
1113 rsum=$(release_checksum $pack)
1114 if [ -n "$rsum" ]; then
1115 old_file=$(awk -F$'\t' -vname="$PACKAGE" '{
1116 if ($1 == name) printf("%s-%s.tazpkg", $1, $2);
1117 }' $PKGS/packages.info)
1118 if [ -f "$PKGS/$old_file" ]; then
1119 action 'Removing old package "%s"' "$old_file"
1120 rm -f "$PKGS/$old_file"
1121 status
1122 fi
1123 # package changed, substitute old package by new
1124 mv -f $pkgdir/taz/$PACKAGE-$VERSION$EXTRAVERSION.tazpkg $PKGS
1125 else
1126 # package not changed, remove new package
1127 rm -f $pkgdir/taz/$PACKAGE-$VERSION$EXTRAVERSION.tazpkg
1128 fi
1130 sed -i "/^${pkg}$/d" $broken
1131 #action 'Removing source tree...'
1132 #rm -f $WOK/$pkg/source; status
1136 # Return all the names of packages bundled in this receipt
1138 all_names() {
1139 local split=" $SPLIT "
1140 if ! head -n1 $WOK/$pkg/receipt | fgrep -q 'v2'; then
1141 # For receipts v1: $SPLIT may present in the $WANTED package,
1142 # but split packages have their own receipts
1143 echo $PACKAGE
1144 elif [ "${split/ $PACKAGE /}" != "$split" ]; then
1145 # $PACKAGE included somewhere in $SPLIT (probably in the end).
1146 # We should build packages in the order defined in the $SPLIT.
1147 echo $SPLIT
1148 else
1149 # We'll build the $PACKAGE, then all defined in the $SPLIT.
1150 echo $PACKAGE $SPLIT
1151 fi
1155 # v2: pack all packages using compiled files
1157 packall() {
1158 set_paths
1159 if head -n1 "$pkgdir/receipt" | fgrep -q 'v2'; then
1160 for i in $(all_names); do
1161 unset TAGS DEPENDS CAT CONFIG_FILES PROVIDE SUGGESTED DATABASE_FILES TAZPANEL_DAEMON
1162 packit $i
1163 done
1164 else
1165 packit
1166 fi
1170 # Reverse "cat" command: prints input lines in the reverse order
1172 tac() {
1173 sed '1!G;h;$!d' $1
1177 # Update chroot with freshly rebuilt package: keep env up-to-date.
1179 update_chroot() {
1180 local PACKAGE="$pkg"
1181 for i in $(all_names); do
1182 if [ -d "$root$INSTALLED/$i" ]; then
1183 . /etc/slitaz/cook.conf
1184 . $WOK/$pkg/taz/$i-$VERSION/receipt
1185 _ 'Updating %s chroot environment...' "$ARCH"
1186 _ 'Updating chroot: %s' "$i ($VERSION$EXTRAVERSION$arch)" | log
1187 cd $PKGS
1188 tazpkg install $i-$VERSION$EXTRAVERSION$arch.tazpkg --forced --root=$root
1189 fi
1190 done
1194 # Install package on --inst or update the chroot.
1196 install_package() {
1197 set_paths
1198 case "$ARCH" in
1199 arm*|x86_64)
1200 arch="-$ARCH"
1201 root="$CROSS_TREE/sysroot" ;;
1202 esac
1203 # Install package if requested but skip install if target host doesn't
1204 # match build system or it will break the build chroot.
1205 build=$(echo $BUILD_SYSTEM | cut -d- -f1)
1206 if [ -n "$inst" -a "$build" == "$ARCH" ]; then
1207 if [ -f "$PKGS/$PACKAGE-$VERSION$EXTRAVERSION.tazpkg" ]; then
1208 cd $PKGS
1209 tazpkg install $PACKAGE-$VERSION$EXTRAVERSION.tazpkg --forced
1210 else
1211 broken
1212 die 'Unable to install package, build has failed.'
1213 fi
1214 fi
1216 update_chroot
1220 # remove chroot jail
1222 umount_aufs() {
1223 tac ${1}rw/aufs-umount.sh | sh
1224 rm -rf ${1}rw
1225 umount ${1}root
1226 rmdir ${1}r*
1230 # Launch the cook command into a chroot jail protected by aufs.
1231 # The current filesystems are used read-only and updates are
1232 # stored in a separate branch.
1234 try_aufs_chroot() {
1236 base="/dev/shm/aufsmnt$$"
1238 # Can we setup the chroot? Is it already done?
1239 grep -q ^AUFS_NOT_SUPPORTED $receipt && return
1240 grep -q ^AUFS_NOT_RAMFS $receipt && base="/mnt/aufsmnt$$"
1241 [ -n "$AUFS_MOUNTS" -a ! -f /aufs-umount.sh ] || return
1242 grep -q ^aufs /proc/modules || modprobe aufs 2> /dev/null || return
1243 mkdir ${base}root ${base}rw || return
1245 _ 'Setup aufs chroot...'
1247 # Sanity check
1248 for i in / /proc /sys /dev/shm /home ; do
1249 case " $AUFS_MOUNTS " in
1250 *\ $i\ *) ;;
1251 *) AUFS_MOUNTS="$AUFS_MOUNTS $i" ;;
1252 esac
1253 done
1254 for mnt in $(ls -d $AUFS_MOUNTS | sort | uniq); do
1255 mount --bind $mnt ${base}root$mnt
1256 if [ $mnt == / ] && ! mount -t aufs -o br=${base}rw:/ none ${base}root; then
1257 _ 'Aufs mount failure'
1258 umount ${base}root
1259 rm -rf ${base}r*
1260 return
1261 fi
1262 echo "umount ${base}root$mnt" >> ${base}rw/aufs-umount.sh
1263 done
1264 trap "umount_aufs ${base}" INT
1266 chroot ${base}root $(cd $(dirname $0); pwd)/$(basename $0) "$@"
1267 status=$?
1269 _ 'Leaving aufs chroot...'
1270 umount_aufs $base
1271 # Install package outside the aufs jail
1272 install_package
1273 exit $status
1277 # Encode predefined XML entities
1279 xml_ent() {
1280 sed -e 's|&|\&amp;|g; s|<|\&lt;|g; s|>|\&gt;|g; s|"|\&quot;|g' -e "s|'|\&apos;|g"
1284 # Create a XML feed for freshly built packages.
1286 gen_rss() {
1287 pubdate=$(date '+%a, %d %b %Y %X')
1288 cat > $FEEDS/$pkg.xml <<EOT
1289 <item>
1290 <title>$PACKAGE $VERSION$EXTRAVERSION</title>
1291 <link>${COOKER_URL}?pkg=${PACKAGE//+/%2B}</link>
1292 <guid>$PACKAGE-$VERSION$EXTRAVERSION</guid>
1293 <pubDate>$pubdate</pubDate>
1294 <description>$(echo -n "$SHORT_DESC" | xml_ent)</description>
1295 </item>
1296 EOT
1300 # Truncate stdout log file to $1 Mb.
1302 loglimit() {
1303 if [ -n "$DEFAULT_LOG_LIMIT" ]; then
1304 tee /dev/stderr | head -qc ${1:-$DEFAULT_LOG_LIMIT}m
1305 else
1306 tee /dev/stderr
1307 fi
1312 # Receipt functions to ease packaging
1315 get_dev_files() {
1316 action 'Getting standard devel files...'
1317 mkdir -p $fs/usr/lib
1318 cp -a $install/usr/lib/pkgconfig $fs/usr/lib
1319 cp -a $install/usr/lib/*a $fs/usr/lib
1320 cp -a $install/usr/include $fs/usr
1321 status
1325 # Function to use in compile_rules() to copy man page from $src to $install
1327 cook_pick_manpages() {
1328 local name section
1329 action 'Copying man pages...'
1331 for i in $@; do
1332 name=$(echo $i | sed 's|\.[gbx]z2*$||')
1333 section=${name##*/}; section=${section##*.}
1334 mkdir -p $install/usr/share/man/man$section
1335 scopy $i $install/usr/share/man/man$section
1336 done
1337 status
1341 # Function to use in compile_rules() to copy documentation from $src to $install
1343 cook_pick_docs() {
1344 local docdir="$install/usr/share/doc/$PACKAGE-$VERSION"
1345 action 'Copying documentation...'
1346 mkdir -p $docdir
1347 cp -r $@ $docdir
1348 chmod -R a+r $docdir
1349 status
1353 # Function to use in genpkg_rules() to copy specified files from $install to $fs
1355 cook_copy_files() {
1356 action 'Copying files...'
1357 cd $install
1358 local i j
1359 IFS=$'\n'
1360 for i in $@; do
1361 for j in $(find . -name $i ! -type d); do
1362 mkdir -p $fs$(dirname ${j#.})
1363 scopy $j $fs$(dirname ${j#.})
1364 done
1365 done
1366 cd - >/dev/null
1367 status
1371 # Function to use in genpkg_rules() to copy specified folders from $install to $fs
1373 cook_copy_folders() {
1374 action 'Copying folders...'
1375 cd $install
1376 local i j
1377 IFS=$'\n'
1378 for i in $@; do
1379 for j in $(find . -name $i -type d); do
1380 mkdir -p $fs$(dirname ${j#.})
1381 cp -a $j $fs$(dirname ${j#.})
1382 done
1383 done
1384 cd - >/dev/null
1385 status
1389 # Common function to copy files, folders and patterns
1391 copy() {
1392 action 'Copying folders and files...'
1393 local i j k filelist=$(mktemp) folderlist=$(mktemp)
1394 IFS=$'\n'
1395 cd $install
1396 find ! -type d | sed 's|\.||' > $filelist
1397 find -type d | sed 's|\.||' > $folderlist
1398 for i in $@; do
1399 case $i in
1400 @std)
1401 # Copy "standard" files (all but "developer files", man pages, documentation, translations)
1402 sed '/\.h$/d; /\.hxx$/d; /\.a$/d; /\.la$/d; /\.pc$/d; /\.pri$/d; /bin\/.*-config$/d;
1403 /\.m4$/d; /\.gir$/d; /\.typelib$/d; /\.vapi$/d; /\.deps$/d; /\.cmake$/d;
1404 /\/Makefile.*/d; /\.inc$/d; /\/include\//d;
1405 /\/share\/man\//d; /\/share\/doc\//d; /\/share\/gtk-doc\//d; /\/share\/info\//d;
1406 /\/share\/devhelp\//d; /\/share\/locale\//d;
1407 /\/share\/bash-completion\//d; /\/lib\/systemd\//d;
1408 /\/fonts\.scale$/d; /\/fonts\.dir$/d;
1409 ' $filelist
1410 ;;
1411 @dev)
1412 # Copy "developer files"
1413 sed -n '/\.h$/p; /\.hxx$/p; /\.a$/p; /\.la$/p; /\.pc$/p; /\.pri$/p; /bin\/.*-config$/p;
1414 /\.m4$/p; /\.gir$/p; /\.typelib$/p; /\.vapi$/p; /\.deps$/p; /\.cmake$/p;
1415 /\/Makefile.*/p; /\.inc$/p; /\/include\//p;
1416 ' $filelist
1417 ;;
1418 */)
1419 # Copy specified folders.
1420 i="${i%/}"
1421 find -type d -path "*/${i#/}" | sed 's|^.||'
1422 ;;
1423 *)
1424 # Copy specified files.
1425 find ! -type d -path "*/${i#/}" | sed 's|^.||'
1426 ;;
1427 esac | sort -u | \
1428 while read j; do
1429 mkdir -p $fs$(dirname "$j")
1430 if [ -d "$install$j" ]; then
1431 cp -a "$install$j" $fs$(dirname "$j")
1432 else
1433 scopy "$install$j" $fs$(dirname "$j")
1434 fi
1435 done
1436 # Copy empty directories
1437 case $i in
1438 @std)
1439 while read j; do
1440 case $j in
1441 # always skip empty man folders, because this will end up
1442 # copying all the man pages to the package
1443 */man/*) continue;;
1444 esac
1445 [ -z "$(ls -A "$install$j")" ] || continue
1446 # directory $j is empty
1447 k="$j"
1448 # make 'ladder' from directories, from root dir to $j
1449 # /a /a/b /a/b/c etc.
1450 while :; do
1451 [ -z "$k" ] && break
1452 echo "$k"
1453 k="${k%/*}"
1454 done | tac | \
1455 # copy dir with its original ownership/permissions if it does not exist
1456 while read k; do
1457 [ -d "$fs$k" ] || cp -a "$install$k" "$fs$k"
1458 done
1459 done < $folderlist
1460 ;;
1461 esac
1462 done
1463 cd - >/dev/null
1464 unset IFS
1465 rm $filelist $folderlist
1466 status
1470 # Remove from current $fs files that already packed (for receipts v2).
1471 # Note: the order in $SPLIT is very important.
1473 remove_already_packed() {
1474 local i j
1475 IFS=$'\n'
1476 for i in $taz/*/files.list; do
1477 while read j; do
1478 [ -f $fs$j -o -h $fs$j ] || continue
1479 rm $fs$j
1480 rmdir --parents --ignore-fail-on-non-empty $fs$(dirname $j)
1481 done < $i
1482 done
1483 unset IFS
1487 # Function to use in genpkg_rules() to copy hicolor icons in specified sizes
1488 # (default: 16 and 48) from $install to $fs
1490 cook_copy_icons() {
1491 local sizes=$@
1492 action 'Copying hicolor icons...'
1493 mkdir -p $fs/usr/share/icons/hicolor
1494 for i in ${sizes:-16 48}; do
1495 [ ! -e "$install/usr/share/icons/hicolor/${i}x$i" ] ||
1496 scopy $install/usr/share/icons/hicolor/${i}x$i \
1497 $fs/usr/share/icons/hicolor
1498 done
1499 status
1503 # Update packages database every time after successful build
1505 update_packages_db() {
1506 # packages.info (unsorted, located near to packages)
1507 local pi="$PKGS/packages.info"
1508 unset_receipt; . $pack/receipt
1509 SIZES=$(echo $PACKED_SIZE $UNPACKED_SIZE | sed 's|\.0||g')
1511 DEPENDS=$(echo $DEPENDS) # remove newlines, tabs and multiple spaces from variable
1513 rsum=$(release_checksum $pack)
1514 if [ -n "$rsum" ]; then
1515 _ 'The release checksum has changed.\n'
1517 sed -i "/^$PACKAGE\t/d" $pi # remove old entry
1518 cat >> $pi <<EOT
1519 $PACKAGE $VERSION$EXTRAVERSION $CATEGORY $SHORT_DESC $WEB_SITE $TAGS $SIZES $DEPENDS $rsum $PROVIDE
1520 EOT
1522 # files.list (uncompressed, unsorted, located in $cache)
1523 local fl="$cache/files.list"
1524 touch $fl
1525 sed -i "/^$PACKAGE: /d" $fl
1526 sed "s/^/$PACKAGE: \0/" $pack/files.list >> $fl
1527 else
1528 _ 'The release checksum has not changed.\n'
1529 fi
1533 # Update split.db once for receipt
1535 update_split_db() {
1536 local db="$cache/split.db"
1537 touch $db
1538 sed -i "/^$pkg\t/d" $db
1539 echo -e "$pkg\t$(all_names)" >> $db
1543 # Recreate whole split.db from scratch
1545 recreate_split_db() {
1546 # Clean
1547 local db="$cache/split.db"
1548 touch $db
1549 > $db
1551 cd $WOK
1552 for pkg in *; do
1553 [ -f "$WOK/$pkg/receipt" ] || continue
1554 unset PACKAGE SPLIT
1555 . $WOK/$pkg/receipt
1556 echo -e "$PACKAGE\t$(all_names)" >> $db
1557 done
1564 # Commands
1567 # cook <package> --deps
1568 [ -n "$deps" ] && {
1569 @@PREFIX@@/libexec/cookutils/deps $1
1570 exit 0
1573 # cook <package> --clean
1574 # cook <package> -c
1575 [ -n "$clean" -o "$2" == '-c' ] && {
1576 action 'Cleaning "%s"' "$1"
1577 cd $WOK/$1; rm -rf install taz source
1578 status; newline
1579 touch $activity # update $activity -> something changed -> update webstat
1580 exit 0
1583 # cook <package> --getsrc
1584 # cook <package> -gs
1585 [ -n "$getsrc" -o "$2" == '-gs' ] && {
1586 title 'Getting source for "%s"' "$1"
1587 receipt="$WOK/$pkg/receipt"
1588 check_pkg_in_wok
1589 unset_receipt
1590 . $receipt
1591 get_source
1592 _ 'Tarball: %s' "$SRC/$TARBALL"; newline
1593 exit 0
1596 # cook <package> --block
1597 # cook <package> -b
1598 [ -n "$block" -o "$2" == '-b' ] && {
1599 action 'Blocking package "%s"' "$1"
1600 [ $(grep "^$1$" $blocked) ] || echo "$1" >> $blocked
1601 status; newline
1602 touch $activity
1603 exit 0
1606 # cook <package> --unblock
1607 # cook <package> -ub
1608 [ -n "$unblock" -o "$2" == '-ub' ] && {
1609 action 'Unblocking package "%s"' "$1"
1610 sed -i "/^$1$/d" $blocked
1611 status; newline
1612 touch $activity
1613 exit 0
1619 case "$1" in
1620 usage|help|-u|-h)
1621 usage ;;
1623 list-wok)
1624 title 'List of %s packages in "%s"' "$ARCH" "$WOK"
1625 cd $WOK
1626 if [ "$ARCH" != 'i486' ]; then
1627 count=0
1628 for pkg in $(fgrep 'HOST_ARCH=' */receipt | egrep "$ARCH|any" | cut -d: -f1)
1629 do
1630 unset HOST_ARCH
1631 . ./$pkg
1632 count=$(($count + 1))
1633 colorize 34 "$PACKAGE"
1634 done
1635 else
1636 count=$(ls | wc -l)
1637 ls -1
1638 fi
1639 footer "$(_p '%s package' '%s packages' "$count" "$(colorize 32 "$count")")"
1640 ;;
1642 activity)
1643 cat $activity ;;
1645 search)
1646 # Just a simple search function, we don't need more actually.
1647 query="$2"
1648 title 'Search results for "%s"' "$query"
1649 cd $WOK; ls -1 | grep "$query"
1650 footer ;;
1652 setup)
1653 # Setup a build environment
1654 check_root
1655 _ 'Cook: setup environment' | log
1656 title 'Setting up your environment'
1657 [ -d $SLITAZ ] || mkdir -p $SLITAZ
1658 cd $SLITAZ
1659 init_db_files
1660 _ 'Checking for packages to install...'
1661 # Use setup pkgs from cross.conf or cook.conf. When cross compiling
1662 # ARCH-setup or 'cross check' should be used before: cook setup
1663 case "$ARCH" in
1664 arm*|x86_64)
1665 [ -x '/usr/bin/cross' ] || die 'ERROR: %s is not installed' 'cross'
1666 _ 'Using config file: %s' '/etc/slitaz/cross.conf'
1667 . /etc/slitaz/cross.conf ;;
1668 esac
1669 for pkg in $SETUP_PKGS; do
1670 if [ -n "$forced" ]; then
1671 tazpkg -gi $pkg --forced
1672 else
1673 [ ! -d "$INSTALLED/$pkg" ] && tazpkg get-install $pkg
1674 fi
1675 done
1677 # Handle --options
1678 case "$2" in
1679 --wok) hg clone $WOK_URL wok || exit 1 ;;
1680 --stable) hg clone $WOK_URL-stable wok || exit 1 ;;
1681 --undigest) hg clone $WOK_URL-undigest wok || exit 1 ;;
1682 --tiny) hg clone $WOK_URL-tiny wok || exit 1 ;;
1683 esac
1685 # SliTaz group and permissions
1686 if ! grep -q ^slitaz /etc/group; then
1687 _ 'Adding group "%s"' 'slitaz'
1688 addgroup slitaz
1689 fi
1690 _ 'Setting permissions for group "%s"...' 'slitaz'
1691 find $SLITAZ -maxdepth 2 -exec chown root.slitaz {} \;
1692 find $SLITAZ -maxdepth 2 -exec chmod g+w {} \;
1693 footer "$(_ 'All done, ready to cook packages :-)')" ;;
1695 *-setup)
1696 # Setup for cross compiling.
1697 arch="${1%-setup}"
1698 check_root
1699 . /etc/slitaz/cook.conf
1700 for pkg in $CROSS_SETUP; do
1701 if [ -n "$forced" ]; then
1702 tazpkg -gi $pkg --forced
1703 else
1704 [ ! -d "$INSTALLED/$pkg" ] && tazpkg -gi $pkg
1705 fi
1706 done
1708 _ 'Cook: setup %s cross environment' "$arch" | log
1709 title 'Setting up your %s cross environment' "$arch"
1710 init_db_files
1711 sed -i \
1712 -e "s|ARCH=.*|ARCH=\"$arch\"|" \
1713 -e "s|CROSS_TREE=.*|CROSS_TREE=\"/cross/$arch\"|" \
1714 -e 's|BUILD_SYSTEM=.*|BUILD_SYSTEM=i486-slitaz-linux|' \
1715 /etc/slitaz/cook.conf
1716 case "$arch" in
1717 arm)
1718 flags='-O2 -march=armv6'
1719 host="$ARCH-slitaz-linux-gnueabi" ;;
1720 armv6hf)
1721 flags='-O2 -march=armv6j -mfpu=vfp -mfloat-abi=hard'
1722 host="$ARCH-slitaz-linux-gnueabi" ;;
1723 armv7)
1724 flags='-Os -march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=softfp -pipe'
1725 host="$ARCH-slitaz-linux-gnueabi" ;;
1726 x86_64)
1727 flags='-O2 -mtune=generic -pipe'
1728 host="$ARCH-slitaz-linux" ;;
1729 esac
1730 sed -i \
1731 -e "s|CFLAGS=.*|CFLAGS=\"$flags\"|" \
1732 -e "s|HOST_SYSTEM=.*|HOST_SYSTEM=$host|" /etc/slitaz/cook.conf
1733 . /etc/slitaz/cook.conf
1734 sysroot="$CROSS_TREE/sysroot"
1735 tools="/cross/$arch/tools"
1736 root="$sysroot"
1737 # L10n: keep the same width of translations to get a consistent view
1738 _ 'Target arch : %s' "$ARCH"
1739 _ 'Configure args : %s' "$CONFIGURE_ARGS"
1740 _ 'Build flags : %s' "$flags"
1741 _ 'Arch sysroot : %s' "$sysroot"
1742 _ 'Tools prefix : %s' "$tools/bin"
1743 # Tell the packages manager where to find packages.
1744 _ 'Packages DB : %s' "$root$DB"
1745 mkdir -p $root$INSTALLED
1746 cd $root$DB; rm -f *.bak
1747 for list in packages.list packages.desc packages.equiv packages.md5; do
1748 rm -f $list
1749 ln -s $SLITAZ/packages/$list $list
1750 done
1751 # We must have the cross compiled glibc-base installed or default
1752 # i486 package will be used as dep by tazpkg and then break the
1753 # cross environment
1754 if [ ! -f "$root$INSTALLED/glibc-base/receipt" ]; then
1755 colorize 36 $(_ 'WARNING: %s is not installed in sysroot' '(e)glibc-base')
1756 fi
1757 # Show GCC version or warn if not yet compiled.
1758 if [ -x "$tools/bin/$HOST_SYSTEM-gcc" ]; then
1759 _ 'Cross compiler : %s' "$HOST_SYSTEM-gcc"
1760 else
1761 colorize 36 $(_ 'C compiler "%s" is missing' "$HOST_SYSTEM-gcc")
1762 _ 'Run "%s" to cook a toolchain' 'cross compile'
1763 fi
1764 footer ;;
1766 test)
1767 # Test a cook environment.
1768 _ 'Cook test: testing the cook environment' | log
1769 [ ! -d "$WOK" ] && exit 1
1770 [ ! -d "$WOK/cooktest" ] && cp -r $DATA/cooktest $WOK
1771 cook cooktest ;;
1773 new)
1774 # Create the package folder and an empty receipt.
1775 pkg="$2"
1776 [ -z "$pkg" ] && usage
1777 newline
1778 [ -d "$WOK/$pkg" ] && die 'Package "%s" already exists.' "$pkg"
1780 action 'Creating folder "%s"' "$WOK/$pkg"
1781 mkdir $WOK/$pkg; cd $WOK/$pkg; status
1783 action 'Preparing the package receipt...'
1784 cp $DATA/receipt .
1785 sed -i "s|^PACKAGE=.*|PACKAGE=\"$pkg\"|" receipt
1786 status; newline
1788 # Interactive mode, asking and seding.
1789 case "$3" in
1790 --interactive|-x)
1791 _ 'Entering interactive mode...'
1792 separator
1793 _ 'Package : %s' "$pkg"
1795 _n 'Version : ' ; read answer
1796 sed -i "s|^VERSION=.*|VERSION=\"$answer\"|" receipt
1798 _n 'Category : ' ; read answer
1799 sed -i "s|^CATEGORY=.*|CATEGORY=\"$answer\"|" receipt
1801 # L10n: Short description
1802 _n 'Short desc : ' ; read answer
1803 sed -i "s|^SHORT_DESC=.*|SHORT_DESC=\"$answer\"|" receipt
1805 _n 'Maintainer : ' ; read answer
1806 sed -i "s|^MAINTAINER=.*|MAINTAINER=\"$answer\"|" receipt
1808 _n 'License : ' ; read answer
1809 sed -i "s|^LICENSE=.*|LICENSE=\"$answer\"|" receipt
1811 _n 'Web site : ' ; read answer
1812 sed -i "s|^WEB_SITE=.*|WEB_SITE=\"$answer\"|" receipt
1813 newline
1815 # Wget URL.
1816 _ 'Wget URL to download source tarball.'
1817 _n 'Example : ' ; echo '$GNU_MIRROR/$PACKAGE/$TARBALL'
1818 _n 'Wget url : ' ; read answer
1819 sed -i "s|^WGET_URL=.*|WGET_URL=\"$answer\"|" receipt
1821 # Ask for a stuff dir.
1822 confirm "$(_n 'Do you need a stuff directory? (y/N)')"
1823 if [ "$?" -eq 0 ]; then
1824 action 'Creating the stuff directory...'
1825 mkdir $WOK/$pkg/stuff; status
1826 fi
1828 # Ask for a description file.
1829 confirm "$(_n 'Are you going to write a description? (y/N)')"
1830 if [ "$?" -eq 0 ]; then
1831 action 'Creating the "%s" file...' 'description.txt'
1832 touch $WOK/$pkg/description.txt; status
1833 fi
1835 footer "$(_ 'Receipt is ready to use.')" ;;
1836 esac ;;
1838 list)
1839 # Cook a list of packages (better use the Cooker since it will order
1840 # packages before executing cook).
1841 check_root
1842 [ -z "$2" ] && die 'No list in argument.'
1843 [ -f "$2" ] || die 'List "%s" not found.' "$2"
1845 _ 'Starting cooking the list "%s"' "$2" | log
1847 while read pkg; do
1848 cook $pkg || broken
1849 done < $2
1850 ;;
1852 clean-wok)
1853 check_root
1854 newline; action 'Cleaning all packages files...'
1855 rm -rf $WOK/*/taz $WOK/*/install $WOK/*/source
1856 status; newline ;;
1858 clean-src)
1859 check_root
1860 newline; action 'Cleaning all packages sources...'
1861 rm -rf $WOK/*/source
1862 status; newline ;;
1864 uncook)
1865 cd $WOK
1866 count=0
1867 title 'Checking for uncooked packages'
1869 for i in *; do
1870 unset HOST_ARCH EXTRAVERSION
1871 [ ! -e $i/receipt ] && continue
1872 . ./$i/receipt
1873 # Source cooked pkg receipt to get EXTRAVERSION
1874 if [ -d "$WOK/$i/taz" ]; then
1875 cd $WOK/$i/taz/$(ls $WOK/$i/taz/ | head -n1)
1876 . ./receipt; cd $WOK
1877 fi
1878 case "$ARCH" in
1879 i486)
1880 debug "$(_ 'Package "%s"' "$PKGS/$PACKAGE-$VERSION$EXTRAVERSION.tazpkg")"
1881 if [ ! -f "$PKGS/$PACKAGE-$VERSION$EXTRAVERSION.tazpkg" ]; then
1882 count=$(($count + 1))
1883 colorize 34 "$i"
1884 fi ;;
1885 arm*)
1886 # Check only packages included in arch
1887 if echo "$HOST_ARCH" | egrep -q "$ARCH|any"; then
1888 # *.tazpkg
1889 if [ ! -f "$PKGS/$PACKAGE-$VERSION$EXTRAVERSION-$ARCH.tazpkg" ]; then
1890 count=$(($count + 1))
1891 colorize 34 "$i"
1892 fi
1893 fi ;;
1894 esac
1895 done
1897 if [ "$count" -gt 0 ]; then
1898 footer "$(_p '%s uncooked package' '%s uncooked packages' "$count" "$(colorize 31 "$count")")"
1899 else
1900 _ 'All packages are cooked :-)'
1901 newline
1902 fi
1903 ;;
1905 pkgdb)
1906 # Create suitable packages list for TazPkg and only for built packages
1907 # as well as flavors files for TazLiTo. We don't need logs since we do it
1908 # manually to ensure everything is fine before syncing the mirror.
1909 recreate_split_db
1910 @@PREFIX@@/libexec/cookutils/pkgdb "$2"
1911 ;;
1913 splitdb)
1914 # File split.db is useful for searching for split packages.
1915 recreate_split_db
1916 ;;
1918 *)
1919 # Just cook and generate a package.
1920 check_root
1921 time=$(date +%s)
1922 pkg="$1"
1923 [ -z "$pkg" ] && usage
1925 # Search last successful cook time in all logs from newer to older
1926 for i in '' $(seq 0 9 | sed 's|^|.|'); do
1927 [ -f "$LOGS/$pkg.log$i" ] || break
1928 lastcooktime=$(sed '/^Cook time/!d; s|.*: *\([0-9]*\)s.*|\1|' \
1929 $LOGS/$pkg.log$i 2>/dev/null | sed '$!d')
1930 [ -n "$lastcooktime" ] && break
1931 done
1933 receipt="$WOK/$pkg/receipt"
1934 check_pkg_in_wok
1935 newline
1937 unset inst
1938 unset_receipt
1939 . $receipt
1941 # Handle cross compilation.
1942 case "$ARCH" in
1943 arm*)
1944 if [ -z "$HOST_ARCH" ]; then
1945 _ 'cook: HOST_ARCH is not set in "%s" receipt' "$pkg"
1946 error="$(_ 'package "%s" is not included in %s' "$pkg" "$ARCH")"
1947 _ 'cook: %s' "$error"
1948 [ -n "$CROSS_BUGS" ] && _ 'bugs: %s' "$CROSS_BUGS"
1949 _ 'Cook skip: %s' "$error" | log
1950 newline
1951 broken; exit 1
1952 fi ;;
1953 esac
1955 # Some packages are not included in some arch or fail to cross compile.
1956 : ${HOST_ARCH=i486}
1957 debug "$(_ 'Host arch %s' "$HOST_ARCH")"
1958 # Handle arm{v6hf,v7,..}
1959 if ! $(echo "$HOST_ARCH" | egrep -q "${ARCH%v[0-9]*}|any"); then
1960 _ 'cook: %s' "HOST_ARCH=$HOST_ARCH"
1961 error="$(_ "package \"%s\" doesn't cook or is not included in %s" "$pkg" "$ARCH")"
1962 _ 'cook: %s' "error"
1963 [ -n "$CROSS_BUGS" ] && _ 'bugs: %s' "$CROSS_BUGS"
1964 _ 'Cook skip: %s' "$error" | log
1965 sed -i "/^${pkg}$/d" $broken
1966 newline
1967 exit 0
1968 fi
1970 # Skip blocked, 3 lines also for the Cooker.
1971 grep -q "^$pkg$" $blocked && [ "$2" != '--unblock' ] &&
1972 die 'Package "%s" is blocked' "$pkg"
1974 try_aufs_chroot "$@"
1976 # Log and source receipt.
1977 _ 'Cook started for: %s' "<a href='cooker.cgi?pkg=${pkg//+/%2B}'>$pkg</a>" | log
1978 echo "cook:$pkg" > $command
1980 [ -n "$lastcooktime" ] && echo "cook:$pkg $lastcooktime $(date +%s)" >> $cooktime
1982 while read cmd duration start; do
1983 [ $(($start + $duration)) -lt $(date +%s) ] &&
1984 echo "sed -i '/^$cmd $duration/d' $cooktime"
1985 done < $cooktime | sh
1987 # Display and log info if cook process stopped.
1988 # FIXME: gettext not working (in single quotes) here!
1989 trap '_ "\n\nCook stopped: control-C\n\n" | \
1990 tee -a $LOGS/$pkg.log' INT
1992 update_split_db
1994 # Handle --options
1995 case "$2" in
1996 --install|-i)
1997 inst='yes' ;;
1999 --pack)
2000 [ -d "$WOK/$pkg/install" ] || die 'Need to build "%s"' "$pkg"
2001 [ ! -d "$WOK/$pkg/taz" ] || rm -rf "$WOK/$pkg/taz"
2002 [ ! -f "$LOGS/$pkg-pack.log" ] || rm -rf $LOGS/$pkg-pack.log
2003 sed -i '$ s|$| (packing)|' $activity
2004 packall 2>&1 | tee -a $LOGS/$pkg-pack.log
2005 clean_log "$pkg-pack"
2006 time=$(($(date +%s) - $time))
2007 summary | sed 's|^Cook |Pack |' | tee -a $LOGS/$pkg-pack.log
2008 sed -i '$ s|$| [ Done ]|' $activity
2009 rm -f $command
2010 exit 0 ;;
2011 esac
2013 # Rotate log
2014 for i in $(seq 9 -1 1); do
2015 j=$(($i - 1))
2016 [ -e $LOGS/$pkg.log.$j ] && mv -f $LOGS/$pkg.log.$j $LOGS/$pkg.log.$i
2017 done
2018 [ -e $LOGS/$pkg.log ] && mv $LOGS/$pkg.log $LOGS/$pkg.log.0
2020 # Check if wanted is built now so we have separate log files.
2021 for wanted in $WANTED ; do
2022 if grep -q "^$wanted$" $blocked; then
2023 broken
2024 rm -f $command
2025 die 'WANTED package "%s" is blocked' "$wanted"
2026 fi
2027 if grep -q "^$wanted$" $broken; then
2028 broken
2029 rm -f $command
2030 die 'WANTED package "%s" is broken' "$wanted"
2031 fi
2032 if [ ! -d "$WOK/$wanted/install" ]; then
2033 cook "$wanted" || { broken; exit 1; }
2034 fi
2035 done
2037 # Cook and pack or exit on error and log everything.
2038 cookit $@ 2>&1 | loglimit 50 > $LOGS/$pkg.log
2039 remove_deps | tee -a $LOGS/$pkg.log
2040 cookit_quality
2041 packall 2>&1 | loglimit 5 >> $LOGS/$pkg.log
2042 clean_log
2044 # Exit if any error in packing.
2045 if [ "${COOKOPTS/skip-log-errors/}" == "$COOKOPTS" ] &&
2046 grep -Ev "(/root/.cvspass|conftest|df: /|rm: can't remove)" $LOGS/$pkg.log | \
2047 grep -Eq "(^ERROR|: No such file or directory|not remade because of errors|ake: \*\*\* .* Error)"; then
2048 debug_info | tee -a $LOGS/$pkg.log
2049 sed -i '$ s|$| [ Failed ]|' $activity
2050 rm -f $command
2051 broken; exit 1
2052 fi
2054 # Create an XML feed
2055 gen_rss
2057 # Time and summary
2058 time=$(($(date +%s) - $time))
2059 summary | tee -a $LOGS/$pkg.log
2060 newline
2062 # We may want to install/update (outside aufs jail!).
2063 [ -s /aufs-umount.sh ] || install_package
2065 sed -i '$ s|$| [ Done ]|' $activity
2067 # Finally we DON'T WANT to build the *-dev or packages with WANTED="$pkg"
2068 # If you want automation, use the Cooker Build Bot.
2069 rm -f $command
2070 ;;
2071 esac
2073 exit 0